# Handle the incoming configuration files:
config() {
  for infile in $1; do
    NEW="$infile"
    OLD="$(dirname $NEW)/$(basename $NEW .new)"
    # If there's no config file by that name, mv it over:
    if [ ! -r $OLD ]; then
      mv $NEW $OLD
    elif [ "$(cat $OLD | md5sum)" = "$(cat $NEW | md5sum)" ]; then
      # toss the redundant copy
      rm $NEW
    fi
    # Otherwise, we leave the .new copy for the admin to consider...
  done
}

preserve_perms() {
  NEW="$1"
  OLD="$(dirname $NEW)/$(basename $NEW .new)"
  if [ -e $OLD ]; then
    cp -a $OLD ${NEW}.incoming
    cat $NEW > ${NEW}.incoming
    mv ${NEW}.incoming $NEW
  fi
  config $NEW
}

config etc/opensc.conf.new

# Update the desktop database:
if [ -x usr/bin/update-desktop-database ]; then
  chroot . /usr/bin/update-desktop-database usr/share/applications > /dev/null 2>&1
fi

# Update hicolor theme cache:
if [ -d usr/share/icons/hicolor ]; then
  if [ -x /usr/bin/gtk-update-icon-cache ]; then
    chroot . /usr/bin/gtk-update-icon-cache -f -t usr/share/icons/hicolor 1> /dev/null 2> /dev/null
  fi
fi

( cd usr/lib ; rm -rf libopensc.so )
( cd usr/lib ; ln -sf libopensc.so.8.0.0 libopensc.so )
( cd usr/lib ; rm -rf libopensc.so.8 )
( cd usr/lib ; ln -sf libopensc.so.8.0.0 libopensc.so.8 )
( cd usr/lib ; rm -rf libsmm-local.so )
( cd usr/lib ; ln -sf libsmm-local.so.8.0.0 libsmm-local.so )
( cd usr/lib ; rm -rf libsmm-local.so.8 )
( cd usr/lib ; ln -sf libsmm-local.so.8.0.0 libsmm-local.so.8 )
( cd usr/lib/pkcs11 ; rm -rf onepin-opensc-pkcs11.so )
( cd usr/lib/pkcs11 ; ln -sf ../onepin-opensc-pkcs11.so onepin-opensc-pkcs11.so )
( cd usr/lib/pkcs11 ; rm -rf opensc-pkcs11.so )
( cd usr/lib/pkcs11 ; ln -sf ../opensc-pkcs11.so opensc-pkcs11.so )
( cd usr/lib/pkcs11 ; rm -rf pkcs11-spy.so )
( cd usr/lib/pkcs11 ; ln -sf ../pkcs11-spy.so pkcs11-spy.so )
